import sys
import pygame
import random

def run_game():
    #initial setup
    pygame.init()
    screen = pygame.display.set_mode((600, 600))
    pygame.display.set_caption("BrickBreaker")
    clock = pygame.time.Clock()
    #create variables
    
    ball_image = pygame.image.load("ball.png")
    paddle_image = pygame.image.load("paddle.png")
    brick_image = pygame.image.load("brick.png")
    ball_x = 150
    ball_y = 400

    paddle_x = 300
    paddle_y = 540

    velocity_x = 5
    velocity_y = 5

    font = pygame.font.SysFont(None, 72)
    win = font.render("You Win!", True, (250,0,0))

    running = True

    brick_locations = [ ]
    for row in range(3):
        for col in range(7):
            x = col * 80 + 30
            y = row * 40 + 50
            brick_locations.append((x, y))
    print(brick_locations)

    #game loop

    while running:
        clock.tick(60)
        #changes based on events
        
        for event in pygame.event.get():
            if event.type == pygame.KEYDOWN:
                if event.key == pygame.K_q:
                    running = False
                
        keys = pygame.key.get_pressed()
        if keys[pygame.K_RIGHT] and paddle_x < 540:
            paddle_x += 10
        if (keys[pygame.K_LEFT] or keys[pygame.K_a]) and paddle_x > 0:
            paddle_x -= 10
                    
        #automatic changes

        ball_x += velocity_x
        ball_y += velocity_y

        if ball_y > 580:
            velocity_y = -5

        if ball_x > 580:
            velocity_x = -5

        if ball_y < 0:
            velocity_y = 5

        if ball_x < 0:
            velocity_x = 5

        #collisions

        ball_rect = pygame.Rect(ball_x, ball_y, 20,20)
        paddle_rect = pygame.Rect(paddle_x, paddle_y, 60, 20)

        if ball_rect.colliderect(paddle_rect):
            velocity_y *= -1
            velocity_x = random.randint(-10, +10)

        for location in brick_locations:
            brick_rect = pygame.Rect(location, (60, 20))
            if ball_rect.colliderect(brick_rect):
                brick_locations.remove(location)
                velocity_y *= -1
                velocity_x = random.randint(-10, +10)
                
                    
        #draw the stuff
        #first a black screen
                    
        screen.fill((20,20,20))
        
        #then stuff on top of the screen
        
        screen.blit(ball_image, (ball_x, ball_y))
        screen.blit(paddle_image, (paddle_x, paddle_y))

        for location in brick_locations:
            screen.blit(brick_image, location)

        if len(brick_locations) == 0:
            screen.blit(win, (200, 300))
        
        #show the new screen
        
        pygame.display.flip()
        
    pygame.quit()


run_game()
